
#include "stdafx.h"
#include "GcaTool.h"
#include "gcasdk/GcaSDK.h"
#pragma comment( lib, "gcasdk/GcaSDK.lib" )

using namespace std;
using namespace nsGcaSDK;

static int dummy_msg_proc( int msg,string,void* ptr )
{
	switch( msg )
	{
	case GCAM_FILE_CRC_ERROR:
	case GCAM_ARC_CRC_ERROR:
	case GCAM_ARC_UNKNOWN_FORMAT:
	case GCAM_ARC_WRITE_ERROR:
	case GCAM_FILE_WRITE_ERROR:
	case GCAM_ARC_CRYPTO_ERROR:
	case GCAM_FILE_CRYPTO_ERROR:
		return GCAM_CANCEL;

	case GCAM_FILE_CRYPTO:
	case GCAM_ARC_CRYPTO:{
		CGca* gca=(CGca*)ptr;
		CGcaTool* tool = (CGcaTool*)gca->GetUser();
		if( tool )
		{
			string s;
			const char* x = tool->pwd();
			if( *x=='#' )
				if( x[1]=='#' )
					x++;
				else
				{
					GetSpellFromKeyFile( s, string(x+1) );
					x = s.c_str();
				}
			gca->SetSpell( string(x) );
			gca->SetCrypto(TRUE);
			gca->SetUser( 0 );
		}}break;
	}
	return GCAM_OK;
}

bool CGcaTool::Check( const char* fname, unsigned long fsize )
{
	FILE* fp = fopen(fname,"rb");
	if( !fp )
		return false;
	int x;
	fseek( fp, x=GetStartOffset( string(fname) ), SEEK_SET );
	bool ans=false;
	if( x!=0 || (fgetc(fp)=='G' && fgetc(fp)=='C' && fgetc(fp)=='A') )
		ans = true;
	fclose( fp );
	return ans;
}

bool CGcaTool::Extract( const char* fname,const char* ddir )
{
	CGca gca;
	if( !gca.Init() )
		return false;

	string nm = fname, dst = ddir;
	gca.SetStartOffset( GetStartOffset( nm ) );
	gca.SetArcFilePath( nm );
	gca.SetOutputPath( dst );
	gca.SetMessageProc( dummy_msg_proc );
	gca.SetUser( (DWORD)this );
	if( !gca.Extract() )
		return false;

	gca.Free();
	return true;
}
